Use CSS styles instead of labelsDivStyles
[dygraphs.git] / release.sh
1 #!/bin/bash
2 # This script "releases" a version of dygraphs.
3
4 if [ $# -ne 1 ]; then
5 echo "Usage: $0 X.Y.Z" >&2
6 exit 1
7 fi
8
9 VERSION=$1
10 echo $VERSION | egrep '\d+\.\d+\.\d+' > /dev/null
11 if [ $? -ne 0 ]; then
12 echo "Version must be of the form 1.2.3 (got '$VERSION')" >&2
13 exit 1
14 fi
15
16 # Make sure this is being run from a release branch with the correct name.
17 branch=$(git rev-parse --abbrev-ref HEAD)
18 if [ $branch != "release-$VERSION" ]; then
19 echo "Must be on a branch named 'release-$VERSION' (found '$branch')" >&2
20 exit 1
21 fi
22
23 git status | grep 'working directory clean' > /dev/null
24 if [ $? -ne 0 ]; then
25 echo "Must release with a clean working directory. Commit your changes." >&2
26 exit 1
27 fi
28
29 make lint test test-combined
30 if [ $? -ne 0 ]; then
31 echo "Tests failed. Won't release!" >&2
32 exit 1
33 fi
34
35 # Push a permanent copy of documentation & generated files to a versioned copy
36 # of the site. This is where the downloadable files are generated.
37 # TODO(danvk): make sure this actually generates the downloadable files!
38 echo "Pushing docs and generated files to dygraphs.com/$VERSION"
39 ./push-to-web.sh dygraphs.com:dygraphs.com/$VERSION
40 if [ $? -ne 0 ]; then
41 echo "Push to web failed" >&2
42 exit 1
43 fi
44
45 # Everything is good.
46 # Switch to the "releases" branch, merge this change and tag it.
47 echo "Switching branches to do the release."
48 git checkout releases
49 git merge --no-ff $branch
50
51 COMMIT=$(git rev-parse HEAD)
52 echo "Tagging commit $COMMIT as version $VERSION"
53 git tag -a "v$VERSION" -m "Release of version $VERSION"
54 git push --tags
55
56 echo "Release was successful!"
57 echo "Pushing the new version to dygraphs.com..."
58 ./push-to-web.sh dygraphs.com:dygraphs.com
59
60 echo "Success!\n"
61 echo "Don't forget to merge changes on this branch back into master:"
62 echo "git merge --no-ff $branch"
63
64 # Discourage users from working on the "releases" branch.
65 git checkout master